'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOptions = {
    ast: false
};

exports.default = function (userOptions) {
    return function (input) {
        return function babel(log) {
            var babelTransform = require('babel-core').babelTransform;

            return new _promise2.default(function (resolve, reject) {
                var files = input.map(function (file) {
                    var options = (0, _extends3.default)({}, defaultOptions, {
                        inputSourceMap: file.map
                    }, userOptions, {
                        filename: file.path
                    });

                    var result = undefined;

                    try {
                        result = babelTransform(file.data, options);

                        return {
                            path: file.path,
                            data: result.code,
                            map: result.map
                        };
                    } catch (err) {
                        reject(err);
                    }
                });

                resolve(files);
            });
        };
    };
};

module.exports = exports['default'];